
%define postgres_uid 64200
%define postgres_gid 64200

%global tcldevel 1
%global test 1
%global plpython 1
%global pltcl 1
%global plperl 1
%global ssl 1
%global kerberos 1
%global ldap 1
%global nls 1
%global xml 1
%global pgfts 1
%global runselftest 0

%define _libdir64 %{_prefix}/lib64

Summary: PostgreSQL client programs
Name: postgresql
%global majorversion 8.4
Version: 8.4.11
Release: 2
# The PostgreSQL license is very similar to other MIT licenses, but the OSI
# recognizes it as an independent license, so we do as well.
License: PostgreSQL
Group: Applications/Databases
URL: http://www.postgresql.org/

Source0: ftp://ftp.postgresql.org/pub/source/v%{version}/%{name}-%{version}.tar.bz2
Source1: ftp://ftp.postgresql.org/pub/source/v%{version}/%{name}-%{version}.tar.bz2.md5
# The PDF file is generated by generate-pdf.sh, which see for comments
Source2: %{name}-%{version}-US.pdf
# generate-pdf.sh is not used during RPM build, but included for documentation
Source3: %{name}-generate-pdf.sh
Source6: %{name}.aix.init
Source7: %{name}-Makefile.regress
Source8: %{name}-pg_config.h
Source9: %{name}-ecpg_config.h
Source10: %{name}-README.rpm-dist
Source11: %{name}-bashprofile
Source20: %{name}-switch-to-32_bit.sh
Source21: %{name}-switch-to-64_bit.sh

# /opt/freeware/include/sqltypes.h collides with a local sqltypes.h (from
# unixODBC-devel), thus do not include -I/opt/freeware/include in $CFLAGS.
# However, to detect krb5 we need -I/opt/freeware/include in $CFLAGS.
Patch0: %{name}-%{version}-aix.patch

BuildRequires: bison, flex, gawk, tar
BuildRequires: bzip2 >= 1.0.2
BuildRequires: perl >= 5.8.8

%if %plpython
BuildRequires: python-devel >= 2.6.2
%endif

%if %pltcl
BuildRequires: tcl >= 8.5.8-2
%if %tcldevel
BuildRequires: tcl-devel >= 8.5.8-2
%endif
%endif

BuildRequires: readline-devel >= 5.2-3
Requires: readline >= 5.2-3
BuildRequires: zlib-devel >= 1.2.3-3
Requires: zlib >= 1.2.3-3

%if %ssl
BuildRequires: openssl-devel >= 0.9.8
Requires: openssl >= 0.9.8
%endif

%if %kerberos
BuildRequires: krb5-devel >= 1.8.3-1
Requires: krb5-libs >= 1.8.3-1
%endif

%if %ldap
BuildRequires: openldap-devel >= 2.4.23
Requires: openldap >= 2.4.23
%endif

%if %nls
BuildRequires: gettext >= 0.10.40
Requires: gettext >= 0.10.40
%endif

%if %xml
BuildRequires: libxml2-devel >= 2.6.32-2, libxslt-devel >= 1.1.24-1
Requires: libxml2 >= 2.6.32-2, libxslt >= 1.1.24-1
%endif

# main package requires -libs subpackage
Requires: %{name}-libs = %{version}-%{release}

Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
PostgreSQL is an advanced Object-Relational database management system
(DBMS) that supports almost all SQL constructs (including
transactions, sub-selects and user-defined types and functions). The
postgresql package includes the client programs and libraries that
you'll need to access a PostgreSQL DBMS server.  These PostgreSQL
client programs are programs that directly manipulate the internal
structure of PostgreSQL databases on a PostgreSQL server. These client
programs can be located on the same machine with the PostgreSQL
server, or may be on a remote machine which accesses a PostgreSQL
server over a network connection. This package contains the docs
in HTML for the whole package, as well as command-line utilities for
managing PostgreSQL databases on a PostgreSQL server. 

If you want to manipulate a PostgreSQL database on a local or remote PostgreSQL
server, you need this package. You also need to install this package
if you're installing the postgresql-server package.

The database is available as 32-bit and 64-bit.


%package libs
Summary: The shared libraries required for any PostgreSQL clients
Group: Applications/Databases
Provides: libpq.so = %{version}-%{release}
Requires: gettext >= 0.10.40
Requires: krb5-libs >= 1.8.3-1
Requires: openldap >= 2.4.23
Requires: openssl >= 0.9.8

%description libs
The postgresql-libs package provides the essential shared libraries for any 
PostgreSQL client program or interface. You will need to install this package
to use any other PostgreSQL package or any clients that need to connect to a
PostgreSQL server.

The library is available as 32-bit and 64-bit.


%package server
Summary: The programs needed to create and run a PostgreSQL server
Group: Applications/Databases
Requires: %{name} = %{version}-%{release}
Requires: %{name}-libs = %{version}-%{release}

%description server
The postgresql-server package includes the programs needed to create
and run a PostgreSQL server, which will in turn allow you to create
and maintain PostgreSQL databases.  PostgreSQL is an advanced
Object-Relational database management system (DBMS) that supports
almost all SQL constructs (including transactions, sub-selects and
user-defined types and functions). You should install
postgresql-server if you want to create and maintain your own
PostgreSQL databases and/or your own PostgreSQL server. You also need
to install the postgresql package.


%package docs
Summary: Extra documentation for PostgreSQL
Group: Applications/Databases
Requires: %{name} = %{version}-%{release}

%description docs
The postgresql-docs package includes some additional documentation for
PostgreSQL.  Currently, this includes the main documentation in PDF format
and source files for the PostgreSQL tutorial.


%package contrib
Summary: Contributed modules distributed with PostgreSQL
Group: Applications/Databases
Requires: %{name} = %{version}-%{release}
Requires: %{name}-libs = %{version}-%{release}

%description contrib
The postgresql-contrib package contains contributed packages that are
included in the PostgreSQL distribution.


%package devel
Summary: PostgreSQL development header files and libraries
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: %{name}-libs = %{version}-%{release}
Requires: readline >= 5.2-3
Requires: gettext >= 0.10.40

%description devel
The postgresql-devel package contains the header files and libraries
needed to compile C or C++ applications which will directly interact
with a PostgreSQL database management server and the ecpg Embedded C
Postgres preprocessor. You need to install this package if you want to
develop applications which will interact with a PostgreSQL server.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc_r -q64" or "gcc -maix64".


%if %plperl
%package plperl
Summary: The Perl procedural language for PostgreSQL
Group: Applications/Databases
Requires: %{name}-server = %{version}-%{release}
Requires: perl(:MODULE_COMPAT_%(eval "`/opt/freeware/bin/perl -V:version`"; echo $version))
Requires: perl >= 5.8.8

%description plperl
PostgreSQL is an advanced Object-Relational database management
system.  The postgresql-plperl package contains the PL/Perl
procedural language for the backend.
%endif


%if %plpython
%package plpython
Summary: The Python procedural language for PostgreSQL
Group: Applications/Databases
Requires: %{name}-server = %{version}-%{release}
Requires: python >= 2.6.2
Requires: gettext >= 0.10.40

%description plpython
PostgreSQL is an advanced Object-Relational database management
system.  The postgresql-plpython package contains the PL/Python
procedural language for the backend.
%endif


%if %pltcl
%package pltcl
Summary: The Tcl procedural language for PostgreSQL
Group: Applications/Databases
Requires: %{name}-server = %{version}-%{release}
Requires: tcl >= 8.5.8-2

%description pltcl
PostgreSQL is an advanced Object-Relational database management
system.  The postgresql-pltcl package contains the PL/Tcl
procedural language for the backend.
%endif


%if %test
%package test
Summary: The test suite distributed with PostgreSQL
Group: Applications/Databases
Requires: %{name}-server = %{version}-%{release}
Requires: readline >= 5.2-3
Requires: gettext >= 0.10.40

%description test
PostgreSQL is an advanced Object-Relational database management
system. The postgresql-test package includes the sources and pre-built
binaries of various tests for the PostgreSQL database management
system, including regression tests and benchmarks.
%endif


############################################################################
#                                                                          #
#                                %prep                                     #
#                                                                          #
############################################################################

%prep
# we need GNU tar to unpack otherwise an error message like this one occurs:
# gmake[3]: *** No rule to make target `utf8_and_euc_jis_2004.o', needed by `utf8_and_euc_jis_2004.so'.  Stop.
export PATH=/opt/freeware/bin:$PATH
%setup -q 
%patch0

cp -p %{SOURCE2} .

# remove .gitignore files to ensure none get into the RPMs
find . -type f -name .gitignore | xargs rm

mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


############################################################################
#                                                                          #
#                                %build                                    #
#                                                                          #
############################################################################

%build
# fail quickly and obviously if user tries to build as root
%if %runselftest
    if [ x"`id -u`" = x0 ] ; then
        echo "postgresql's regression tests fail if run as root."
        echo "If you really need to build the RPM as root, use"
        echo "--define='runselftest 0' to skip the regression tests."
        exit 1
    fi
%endif

export CC="xlc_r"

############################### 64-bit BEGIN ##############################

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export PERL=/opt/freeware/bin/perl_64bit
export PYTHON=/opt/freeware/bin/python_64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"

./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
%if %plperl
    --with-perl \
%endif
%if %pltcl
    --with-tcl \
    --with-tclconfig=%{_libdir} \
%endif
%if %plpython
    --with-python \
%endif
%if %ldap
    --with-ldap \
%endif
%if %ssl
    --with-openssl \
%endif
%if %kerberos
    --with-krb5 \
%endif
%if %xml
    --with-libxml \
    --with-libxslt \
%endif
%if %nls
    --enable-nls \
%endif
%if %pgfts
    --enable-thread-safety \
%endif
    --sysconfdir=/etc/sysconfig/%{name}

make %{?_smp_mflags} all

# Have to hack makefile to put correct path into tutorial scripts
sed "s|C=\`pwd\`;|C=%{_libdir}/%{name}/tutorial;|" < src/tutorial/Makefile > src/tutorial/GNUmakefile
make %{?_smp_mflags} -C src/tutorial NO_PGXS=1 all
rm -f src/tutorial/GNUmakefile

%if %runselftest
    cd src/test/regress
    make all
    make MAX_CONNECTIONS=5 check
    make clean
    cd ../../..
%endif

%if %test
    cd src/test/regress
    make all
    cd ../../..
%endif

############################### 64-bit END ##############################

############################### 32-bit BEGIN ##############################

cd ../32bit
# now build the 64-bit version
export OBJECT_MODE=32
export PERL=/opt/freeware/bin/perl
export PYTHON=/opt/freeware/bin/python
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"

./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
%if %plperl
    --with-perl \
%endif
%if %pltcl
    --with-tcl \
    --with-tclconfig=%{_libdir} \
%endif
%if %plpython
    --with-python \
%endif
%if %ldap
    --with-ldap \
%endif
%if %ssl
    --with-openssl \
%endif
%if %kerberos
    --with-krb5 \
%endif
%if %xml
    --with-libxml \
    --with-libxslt \
%endif
%if %nls
    --enable-nls \
%endif
%if %pgfts
    --enable-thread-safety \
%endif
    --sysconfdir=/etc/sysconfig/%{name}

make %{?_smp_mflags} all

# Have to hack makefile to put correct path into tutorial scripts
sed "s|C=\`pwd\`;|C=%{_libdir}/%{name}/tutorial;|" < src/tutorial/Makefile > src/tutorial/GNUmakefile
make %{?_smp_mflags} -C src/tutorial NO_PGXS=1 all
rm -f src/tutorial/GNUmakefile

%if %runselftest
    cd src/test/regress
    make all
    make MAX_CONNECTIONS=5 check
    make clean
    cd ../../..
%endif

%if %test
    cd src/test/regress
    make all
    cd ../../..
%endif

############################### 32-bit END ##############################


############################################################################
#                                                                          #
#                                %install                                  #
#                                                                          #
############################################################################

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

# multilib header hack; note pg_config.h is installed in two places!
mv ${RPM_BUILD_ROOT}%{_includedir}/pg_config.h ${RPM_BUILD_ROOT}%{_includedir}/pg_config-ppc64.h
mv ${RPM_BUILD_ROOT}%{_includedir}/%{name}/server/pg_config.h ${RPM_BUILD_ROOT}%{_includedir}/%{name}/server/pg_config-ppc64.h

mv ${RPM_BUILD_ROOT}%{_includedir}/ecpg_config.h ${RPM_BUILD_ROOT}%{_includedir}/ecpg_config-ppc64.h

cd ../32bit
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in `ls -1 | grep -v _64` ; do
    mv -f ${f} ${f}_32
  done
)

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

# make the 64-bit version the default version
(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for file in `ls -1 | grep -v _64` ; do
    f=`basename ${file} _32`
    ln -s ${f}_64 ${f}
  done

  cp %{SOURCE20} .
  cp %{SOURCE21} .
  chmod 0755 %{name}-switch-to-*.sh
)

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in ecpg ecpg_compat pgtypes pq ; do
    /usr/bin/ar -X64 -x lib${f}.a
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in ecpg ecpg_compat pgtypes pq ; do
    /usr/bin/ar -X32 -x lib${f}.a
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
for i in ecpg ecpg_compat pgtypes pq ; do
  /usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib${i}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib${i}.so*
done

# multilib header hack; note pg_config.h is installed in two places!
mv ${RPM_BUILD_ROOT}%{_includedir}/pg_config.h ${RPM_BUILD_ROOT}%{_includedir}/pg_config-ppc32.h
mv ${RPM_BUILD_ROOT}%{_includedir}/%{name}/server/pg_config.h ${RPM_BUILD_ROOT}%{_includedir}/%{name}/server/pg_config-ppc32.h
cp %{SOURCE8} ${RPM_BUILD_ROOT}%{_includedir}/pg_config.h
cp %{SOURCE8} ${RPM_BUILD_ROOT}%{_includedir}/%{name}/server/pg_config.h

mv ${RPM_BUILD_ROOT}%{_includedir}/ecpg_config.h ${RPM_BUILD_ROOT}%{_includedir}/ecpg_config-ppc32.h
cp %{SOURCE9} ${RPM_BUILD_ROOT}%{_includedir}/ecpg_config.h

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/%{name}/tutorial
chmod 0755 ${RPM_BUILD_ROOT}%{_libdir}/%{name}/tutorial
cp src/tutorial/* ${RPM_BUILD_ROOT}%{_libdir}/%{name}/tutorial/

# prep the initscript, including insertion of some values it needs
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d
sed -e 's|^PGVERSION=.*$|PGVERSION=%{version}|' \
	-e 's|^PGDOCDIR=.*$|PGDOCDIR=%{_docdir}/%{name}-%{version}|' \
	< %{SOURCE6} > %{name}.init
cp %{name}.init ${RPM_BUILD_ROOT}/etc/rc.d/init.d/%{name}
chmod 0755 ${RPM_BUILD_ROOT}/etc/rc.d/init.d/%{name}

# PGDATA needs removal of group and world permissions due to pg_pwd hole.
mkdir -p ${RPM_BUILD_ROOT}/var/lib/%{name}/data
chmod 0700 ${RPM_BUILD_ROOT}/var/lib/%{name}/data

# backups of data go here...
mkdir -p ${RPM_BUILD_ROOT}/var/lib/%{name}/backups
chmod 0700 ${RPM_BUILD_ROOT}/var/lib/%{name}/backups

# postgres' .bash_profile
cp %{SOURCE11} ${RPM_BUILD_ROOT}/var/lib/%{name}/.bash_profile
chmod 0644 %{SOURCE11} ${RPM_BUILD_ROOT}/var/lib/%{name}/.bash_profile

# Create the multiple postmaster startup directory
mkdir -p ${RPM_BUILD_ROOT}/etc/sysconfig/%{name}
chmod 0700 ${RPM_BUILD_ROOT}/etc/sysconfig/%{name}

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/%{name}/pgxs/src/backend/port/aix
mkdir -p ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/pgxs/src/backend/port/aix
cp src/backend/port/aix/mkldexport.sh \
    ${RPM_BUILD_ROOT}%{_libdir}/%{name}/pgxs/src/backend/port/aix
cp src/backend/port/aix/mkldexport.sh \
    ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/pgxs/src/backend/port/aix
chmod 0755 ${RPM_BUILD_ROOT}%{_libdir}/%{name}/pgxs/src/backend/port/aix/mkldexport.sh
chmod 0755 ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/pgxs/src/backend/port/aix/mkldexport.sh

%if %test
cd ../64bit
(
    # tests. There are many files included here that are unnecessary,
    # but include them anyway for completeness.  We replace the original
    # Makefiles, however.
    mkdir -p ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/test
    cp -p -r src/test/regress ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/test
    cd ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/test/regress
    strip -X32_64 *.so
    rm -f GNUmakefile Makefile *.o
    cp %{SOURCE7} ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/test/regress/Makefile
    chmod 0644 ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/test/regress/Makefile
)
cd ../32bit
(
    # tests. There are many files included here that are unnecessary,
    # but include them anyway for completeness.  We replace the original
    # Makefiles, however.
    mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/%{name}/test
    cp -p -r src/test/regress ${RPM_BUILD_ROOT}%{_libdir}/%{name}/test
    cd ${RPM_BUILD_ROOT}%{_libdir}/%{name}/test/regress
    strip -X32_64 *.so
    rm -f GNUmakefile Makefile *.o
    cp %{SOURCE7} ${RPM_BUILD_ROOT}%{_libdir}/%{name}/test/regress/Makefile
    chmod 0644 ${RPM_BUILD_ROOT}%{_libdir}/%{name}/test/regress/Makefile
)
%endif

# Fix some more documentation
# gzip doc/internals.ps
cp %{SOURCE10} README.rpm-dist
mv ${RPM_BUILD_ROOT}%{_datadir}/doc/%{name}/html doc
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/doc/%{name}

# %find_lang does not find *any* message catalogs, thus use my own version
my_find_lang()
{
  /usr/bin/find ${RPM_BUILD_ROOT} -name $1.mo | \
      /usr/bin/sed "s|${RPM_BUILD_ROOT}||g" > $1.lang
}

my_find_lang ecpg-%{majorversion}
cat ecpg-%{majorversion}.lang > devel.lst
my_find_lang ecpglib6-%{majorversion}
cat ecpglib6-%{majorversion}.lang > libs.lst
my_find_lang initdb-%{majorversion}
cat initdb-%{majorversion}.lang > server.lst
my_find_lang libpq5-%{majorversion}
cat libpq5-%{majorversion}.lang >> libs.lst
my_find_lang pg_controldata-%{majorversion}
cat pg_controldata-%{majorversion}.lang >> server.lst
my_find_lang pg_ctl-%{majorversion}
cat pg_ctl-%{majorversion}.lang >> server.lst
my_find_lang pg_config-%{majorversion}
cat pg_config-%{majorversion}.lang > main.lst
my_find_lang pg_dump-%{majorversion}
cat pg_dump-%{majorversion}.lang >> main.lst
my_find_lang pg_resetxlog-%{majorversion}
cat pg_resetxlog-%{majorversion}.lang >> server.lst
my_find_lang pgscripts-%{majorversion}
cat pgscripts-%{majorversion}.lang >> main.lst
%if %plperl
my_find_lang plperl-%{majorversion}
cat plperl-%{majorversion}.lang > plperl.lst
%endif
my_find_lang plpgsql-%{majorversion}
cat plpgsql-%{majorversion}.lang >> server.lst
%if %plpython
my_find_lang plpython-%{majorversion}
cat plpython-%{majorversion}.lang > plpython.lst
%endif
%if %pltcl
my_find_lang pltcl-%{majorversion}
cat pltcl-%{majorversion}.lang > pltcl.lst
%endif
my_find_lang postgres-%{majorversion}
cat postgres-%{majorversion}.lang >> server.lst
my_find_lang psql-%{majorversion}
cat psql-%{majorversion}.lang >> main.lst


%pre server
# add the "postgres" group only if it does not yet exist
result=`/usr/sbin/lsgroup postgres | /usr/bin/awk '{ print $1 }' 2>/dev/null`
if [[ "${result}" != "postgres" ]] ; then
    /usr/bin/mkgroup -A id=%{postgres_gid} postgres 2> /dev/null || :
fi
# add the "postgres" user only if it does not yet exist
result=`/usr/sbin/lsuser postgres| /usr/bin/awk '{ print $1 }' 2>/dev/null`
if [[ "${result}" != "postgres" ]] ; then
    /usr/bin/mkuser id=%{postgres_uid} pgrp='postgres' gecos='PostgreSQL Server' \
        home='/var/lib/%{name}' \
        login='true' rlogin='true' postgres 2> /dev/null || :
fi


%preun server
if [ $1 = 0 ] ; then
    /etc/rc.d/init.d/%{name} stop >/dev/null 2>&1
fi
# remove "postgres" user and group
/usr/sbin/rmuser -p postgres || :
/usr/sbin/rmgroup postgres || :


%postun server
if [ $1 -ge 1 ] ; then
    /etc/rc.d/init.d/%{name} condrestart >/dev/null 2>&1 || :
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files -f 32bit/main.lst
%defattr(-,root,system)
%doc 32bit/doc/KNOWN_BUGS 32bit/doc/MISSING_FEATURES 32bit/doc/README*
%doc 32bit/COPYRIGHT 32bit/README 32bit/HISTORY 32bit/doc/bug.template
%doc 32bit/README.rpm-dist
%doc 32bit/doc/html
%{_bindir}/clusterdb*
%{_bindir}/createdb*
%{_bindir}/createlang*
%{_bindir}/createuser*
%{_bindir}/dropdb*
%{_bindir}/droplang*
%{_bindir}/dropuser*
%{_bindir}/pg_config*
%{_bindir}/pg_dump*
%{_bindir}/pg_restore*
%{_bindir}/psql*
%{_bindir}/reindexdb*
%{_bindir}/vacuumdb*
%{_bindir}/%{name}-switch-to-*.sh
%{_mandir}/man1/clusterdb.*
%{_mandir}/man1/createdb.*
%{_mandir}/man1/createlang.*
%{_mandir}/man1/createuser.*
%{_mandir}/man1/dropdb.*
%{_mandir}/man1/droplang.*
%{_mandir}/man1/dropuser.*
%{_mandir}/man1/pg_config.*
%{_mandir}/man1/pg_dump.*
%{_mandir}/man1/pg_dumpall.*
%{_mandir}/man1/pg_restore.*
%{_mandir}/man1/psql.*
%{_mandir}/man1/reindexdb.*
%{_mandir}/man1/vacuumdb.*
%{_mandir}/man7/*
%dir %{_libdir}/%{name}
%dir %{_libdir64}/%{name}


%files docs
%defattr(-,root,system)
%doc 32bit/*-US.pdf
%{_libdir}/%{name}/tutorial/


%files contrib
%defattr(-,root,system)
%doc 32bit/contrib/spi/*.example


%files libs -f 32bit/libs.lst
%defattr(-,root,system)
%doc 32bit/COPYRIGHT
%{_libdir}/libecpg.a
%{_libdir}/libecpg.so*
%{_libdir64}/libecpg.so*
%{_libdir}/libecpg_compat.a
%{_libdir}/libecpg_compat.so*
%{_libdir64}/libecpg_compat.so*
%{_libdir}/libpgport.a
%{_libdir64}/libpgport.a
%{_libdir}/libpgtypes.a
%{_libdir}/libpgtypes.so*
%{_libdir64}/libpgtypes.so*
%{_libdir}/libpq.a
%{_libdir}/libpq.so*
%{_libdir64}/libpq.so*


%files server -f 32bit/server.lst
%defattr(-,root,system)
/etc/rc.d/init.d/postgresql
%attr (755,root,system) %dir /etc/sysconfig/%{name}
%{_bindir}/initdb*
%{_bindir}/pg_controldata*
%{_bindir}/pg_ctl*
%{_bindir}/pg_resetxlog*
%{_bindir}/postgres*
%{_bindir}/postmaster*
%{_libdir}/%{name}/dict_snowball.so
%{_libdir64}/%{name}/dict_snowball.so
%{_libdir}/%{name}/plpgsql.so
%{_libdir64}/%{name}/plpgsql.so
%{_libdir}/%{name}/*_and_*.so
%{_libdir64}/%{name}/*_and_*.so
%{_mandir}/man1/initdb.*
%{_mandir}/man1/pg_controldata.*
%{_mandir}/man1/pg_ctl.*
%{_mandir}/man1/pg_resetxlog.*
%{_mandir}/man1/postgres.*
%{_mandir}/man1/postmaster.*
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/postgres.bki
%{_datadir}/%{name}/postgres.description
%{_datadir}/%{name}/postgres.shdescription
%{_datadir}/%{name}/system_views.sql
%{_datadir}/%{name}/*.sample
%{_datadir}/%{name}/timezone/
%{_datadir}/%{name}/timezonesets/
%{_datadir}/%{name}/tsearch_data/
%{_datadir}/%{name}/conversion_create.sql
%{_datadir}/%{name}/information_schema.sql
%{_datadir}/%{name}/snowball_create.sql
%{_datadir}/%{name}/sql_features.txt
%attr(700,postgres,postgres) %dir /var/lib/%{name}
%attr(700,postgres,postgres) %dir /var/lib/%{name}/data
%attr(700,postgres,postgres) %dir /var/lib/%{name}/backups
%attr(644,postgres,postgres) %config(noreplace) /var/lib/%{name}/.bash_profile


%files devel -f 32bit/devel.lst
%defattr(-,root,system)
%{_bindir}/ecpg*
%{_includedir}/*
%{_libdir}/%{name}/pgxs/
%{_libdir64}/%{name}/pgxs/
%{_libdir}/%{name}/postgres.imp
%{_libdir64}/%{name}/postgres.imp
%{_mandir}/man1/ecpg.*


%if %plperl
%files plperl -f 32bit/plperl.lst
%defattr(-,root,system)
%{_libdir}/%{name}/plperl.so
%{_libdir64}/%{name}/plperl.so
%endif


%if %pltcl
%files pltcl -f 32bit/pltcl.lst
%defattr(-,root,system)
%{_bindir}/pltcl_delmod*
%{_bindir}/pltcl_listmod*
%{_bindir}/pltcl_loadmod*
%{_libdir}/%{name}/pltcl.so
%{_libdir64}/%{name}/pltcl.so
%{_datadir}/%{name}/unknown.pltcl
%endif


%if %plpython
%files plpython -f 32bit/plpython.lst
%defattr(-,root,system)
%{_libdir}/%{name}/plpython.so
%{_libdir64}/%{name}/plpython.so
%endif


%if %test
%files test
%defattr(-,postgres,postgres)
%attr(-,postgres,postgres) %dir %{_libdir}/%{name}/test
%attr(-,postgres,postgres) %dir %{_libdir64}/%{name}/test
%attr(-,postgres,postgres) %{_libdir}/%{name}/test/*
%attr(-,postgres,postgres) %{_libdir64}/%{name}/test/*
%endif


%changelog
* Fri Dec 07 2012 Michael Perzl <michael@perzl.org> - 8.4.11-2
- added missing 64-bit shared objects to archive libraries
- added symlinks to easily switch between the 32-bit and 64-bit version

* Fri Apr 20 2012 Michael Perzl <michael@perzl.org> - 8.4.11-1
- updated to version 8.4.11

* Fri Apr 20 2012 Michael Perzl <michael@perzl.org> - 8.4.10-1
- updated to version 8.4.10

* Fri Apr 20 2012 Michael Perzl <michael@perzl.org> - 8.4.9-1
- updated to version 8.4.9

* Thu Aug 25 2011 Michael Perzl <michael@perzl.org> - 8.4.8-1
- updated to version 8.4.8

* Wed Mar 16 2011 Michael Perzl <michael@perzl.org> - 8.4.7-1
- first version for AIX V5.1 and higher
